import "dart:math" as m;

class MinMax {
  num min;
  num max;
  MinMax(this.min, this.max) {}
}

class Individual {
  List<num> vector;
  List<num> strategy;
  num fitness = 0;
  Configuration c;
  List<MinMax> search_space;
  Individual(List<num> this.vector, Configuration this.c) {
    this.search_space = c.space;
    this.strategy = c.strategy;
  }
// List<num> this.strategy, List<MinMax>  this.search_space
  List<num> mutate_strategy(List<num> stdevs) {
    num tau = m.pow(m.sqrt(2.0 * (stdevs.length)), -1.0);
    num tau_p = m.pow(m.sqrt(2.0 * m.sqrt(stdevs.length)), -1.0);
    m.Random r = new m.Random();
    List<num> child = stdevs
        .map((i) =>
            stdevs[i] * m.exp(tau_p * r.nextDouble() + tau * r.nextDouble()))
        .toList();
    return child;
  }

  List<num> objective_function(List<num> vector) {
    return vector.fold(0.0, (sum, x) => sum + (m.pow(x, 2.0)));
  }

  List<double> random_vector(List<MinMax> minmax) {
    m.Random r = new m.Random();
    return minmax.map((i) => i.min + ((i.max - i.min * r.nextDouble())));
  }

  double random_gaussian({num mean = 0.0, num stdev = 1.0}) {
    double u1 = 0.0;
    double u2 = 0.0;
    double w = 0.0;
    m.Random r = new m.Random();
    do {
      u1 = 2 * r.nextDouble() - 1;
      u2 = 2 * r.nextDouble() - 1;
      w = u1 * u1 + u2 * u2;
    } while (w >= 1);

    w = m.sqrt((-2.0 * m.log(w)) / w);
    return mean + (u2 * w) * stdev;
  }

  List<T> ewi<T>(List<T> l, T fu(int, T)) {
    List<T> lrem = l.reversed.toList();
    int len = l.length;
    List<T> res = new List<T>();
    int z = 0;

    do {
      var las = lrem.last;
      res.add(fu(z, las));
      lrem.removeLast();
      z = z + 1;
    } while (z < len);

    return res;
  }

  Individual mutate() {
    return new Individual(
        mutate_problem(this.vector, this.strategy, this.search_space), c);
  }

  List<num> mutate_problem(
      List<num> vector, List<num> stdevs, List<MinMax> search_space) {
    m.Random r = new m.Random();
    List<num> child = new List<num>();

    return ewi<num>(vector, (num i, num v) {

      var toadd = v + stdevs[i] * r.nextDouble();

/*
      if (toadd < search_space[i].min) {
        toadd = search_space[i].min;
      }
      if (toadd > search_space[i].max) {
        toadd = search_space[i].max;
      }

  */

      child.add(toadd);

      return child;
    });
  }

  String toString() {
    return ("Individual " +
        "Fitness: " +
        this.fitness.toString() +
        " Vector: " +
        this.vector.toString());
  }
}

class Configuration {
  List<MinMax> space;
  List<num> strategy;
  Configuration(this.strategy, this.space) {}
}

void main() {
  var problem_size = 2;
  List<MinMax> search_space = new List<MinMax>();
  num i = 0;
  do {
    var mm = new MinMax(-5.0, 5.0);

    search_space.add(mm);
    i++;
  } while (i < problem_size);
  var max_gens = 100;
  var pop_size = 30;
  var num_children = 20;
  // VSFEntity best = search(max_gens, search_space, pop_size, num_children);
  // print("done! Solution: f=${best.f}, s=${best.v} inspect}");
  Configuration c = new Configuration(
      [1, 2, 3], [new MinMax(-3, 3), new MinMax(-3, 3), new MinMax(-3, 3)]);
  Individual n = new Individual([1, 2, 3], c);

  var n2 = n.mutate();

  print(n);
  print(n2);
}
